var webpack = require('webpack')
var webpackDevMiddleware = require('webpack-dev-middleware')
var webpackHotMiddleware = require('webpack-hot-middleware')

var path = require('path');

function middleware(params, confDir) {

  var compiler = webpack(config);

  var confDir ||  pathLib.join(process.cwd(), ".config");

  var config = require(path.join(confDir, './config/webpack.dev.config'));

  var flexConfig = require(path.join(confDir, './config/flex-combo.json'));

  var devHanlder = webpackDevMiddleware(compiler, {
    publicPath: config.output.publicPath
    stats: {colors: true}
  }));

  // app.use(webpackHotMiddleware(compiler, {
  //   log: console.log
  // }))
  
  return function (req, res, next) {
    // 处理并且编译req.url呢
    // next执行时，包装再撤回req.url
    for(var k in flexConfig.filter) {
      regx = new RegExp(k);

      if(regx.test(req.url)) {
            req.url = req.url.replace(regx, flexConfig.filter[k]);
      }

      // return url;
    }


    devHanlder(req, res, next);
  }
}